<template>
  <q-page class="bg-grey-3">
    <q-toolbar class="bg-blue-10 text-white shadow-2">
      <q-toolbar-title class="q-ml-sm">Cài đặt</q-toolbar-title>
    </q-toolbar>
    <q-card class="q-ma-md">
      <q-card-section>
        <q-form @submit.prevent="onSubmit">
          <q-input
            v-model="settingForm.contributorShippingFee"
            outlined
            label="Phí giao hàng (dành cho thành viên)"
            class="q-mb-md"
          />
          <q-input
            v-model="settingForm.contributorEducatedShippingFee"
            outlined
            label="Phí giao hàng (dành cho thành viên đã đi học)"
            class="q-mb-md"
          />
          <q-input
            v-model="settingForm.saleShippingFee"
            outlined
            label="Phí giao hàng (dành cho địa điểm bán hàng)"
            class="q-mb-md"
          />
          <q-input
            v-model="settingForm.deliveryShippingFee"
            outlined
            label="Phí giao hàng (dành cho địa điểm giao hàng)"
            class="q-mb-md"
          />
          <q-btn label="Lưu cài đặt" type="submit" color="primary" />
        </q-form>
      </q-card-section>
    </q-card>
  </q-page>
</template>

<script>
import { mapActions, mapState } from 'vuex';

export default {
  data() {
    return {
      settingForm: {
        contributorShippingFee: '',
        contributorEducatedShippingFee: '',
        saleShippingFee: '',
        deliveryShippingFee: ''
      }
    };
  },
  computed: {
    ...mapState({
      settings: state => state.settings.settings
    })
  },
  watch: {
    settings: {
      handler() {
        const contributorShippingFee = this.settings.find(
          s => s.settingName === 'contributor_shipping_fee'
        );
        const contributorEducatedShippingFee = this.settings.find(
          s => s.settingName === 'contributor_educated_shipping_fee'
        );
        const saleShippingFee = this.settings.find(
          s => s.settingName === 'sale_shipping_fee'
        );
        const deliveryShippingFee = this.settings.find(
          s => s.settingName === 'delivery_shipping_fee'
        );

        this.settingForm = {
          contributorShippingFee: contributorShippingFee
            ? contributorShippingFee.settingValue
            : '',
          contributorEducatedShippingFee: contributorEducatedShippingFee
            ? contributorEducatedShippingFee.settingValue
            : '',
          saleShippingFee: saleShippingFee ? saleShippingFee.settingValue : '',
          deliveryShippingFee: deliveryShippingFee
            ? deliveryShippingFee.settingValue
            : ''
        };
      },
      immediate: true
    }
  },
  methods: {
    ...mapActions({
      updateSettings: 'settings/updateSettings'
    }),
    onSubmit() {
      this.updateSettings([
        {
          settingName: 'contributor_shipping_fee',
          settingValue: this.settingForm.contributorShippingFee
        },
        {
          settingName: 'contributor_educated_shipping_fee',
          settingValue: this.settingForm.contributorEducatedShippingFee
        },
        {
          settingName: 'sale_shipping_fee',
          settingValue: this.settingForm.saleShippingFee
        },
        {
          settingName: 'delivery_shipping_fee',
          settingValue: this.settingForm.deliveryShippingFee
        }
      ]);
    }
  }
};
</script>
